---
name: Bug report
about: Report unexpected or incorrect behaviour
title: ''
labels: bug
assignees: ''

---

## Describe the bug

<!--
  A clear and concise description of what the bug is.

  If you have a problem with a specific package or NixOS,
  you probably want to file an issue at https://github.com/NixOS/nixpkgs/issues.
-->

## Steps To Reproduce

<!--
  Example:

  1. Clone this repository: ...
  2. Run `nix-... ...`
  3. Observe unexpected behaviour
-->

## Expected behavior

<!-- A clear and concise description of what you expected to happen. -->

## Metadata

<!-- Please insert the output of running `nix-env --version` below this line -->

## Additional context

<!-- Add any other context about the problem here. -->

## Checklist

<!-- make sure this issue is not redundant or obsolete -->

- [ ] checked [latest Nix manual] \([source])
- [ ] checked [open bug issues and pull requests] for possible duplicates

[latest Nix manual]: https://nixos.org/manual/nix/unstable/
[source]: https://github.com/NixOS/nix/tree/master/doc/manual/source
[open bug issues and pull requests]: https://github.com/NixOS/nix/labels/bug

---

Add :+1: to [issues you find important](https://github.com/NixOS/nix/issues?q=is%3Aissue+is%3Aopen+sort%3Areactions-%2B1-desc).
